//+------------------------------------------------------------------+
//|                                                     hltimes1.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Deetrader999"
#property link      "http://catget@comcast.net"
//---- input parameters
extern int MAGICMA= 1000;
extern double    TakeProfit=10000.0;
extern double    Lots=0.1;
extern double    TrailingStop=0.0;
extern double  slip=3.0;
extern double perc=0.015;
int  bn=0, cn=0,d=0,lastnum=0;
static datetime lastbar;
extern bool bopin=True, sopin=False;
extern int stoploss = 35;
bool curnum=True, endtr=True, closehour=false;
double    atrp, bslss, sslss;
int  Current=0 ;
double  bgamult=0, bgain, bmo, sgamult=0, sgain, smo;
extern int bmoved=3, smoved=3,extra=3,maperiods=5;
int stp,tkp,slp,pos,mult;
extern double prof=0;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
lastbar=Time[1];
   stp=stoploss;
   tkp=TakeProfit;
   slp=slip;
   if(Digits==5||Digits==3)
  {
  mult=10;
  }
  else mult=1;
  stp=stp*mult;
  tkp=tkp*mult;
  slp=slp*mult;
  bmoved=bmoved*mult;
  smoved=smoved*mult;
  prof=prof*mult;
  extra=extra*mult;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
//---Do every tick stuff here
   
   int cnt, ticket, total;
   double shortEma, longEma, stopllevel;
   
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
//Do once per bar stuff here     
     

//if( Hour()<=0 && Hour()<4|| Hour()>=4 && Hour()<8||
//Hour()>=8 && Hour()<12|| Hour()>=12 && Hour()<16||
//Hour()>=16 && Hour()<20|| Hour()>=20 && Hour()<0)
//if(Hour()==0 || Hour()==4 || Hour()==8 || Hour()==12 || Hour()==16 || Hour()==20)
//  {
   if (IsNewBar()) //IsNewBar checks for a new bar & does once per bar stuff
//curnum does one trade, order per bar and ok to do if true
// bopin sets to 0 each bar and 1 if a buy opinion given, sopin  fora sell opinion
   {
   
   //Do new bar stuff 

   endtr=True;
   curnum=True;
//   Print("time",Time[0]);
  }  //isnewbar 
    atrp=iATR(NULL, 0, 14, Current + 1)*perc;
    double sar1 = iSAR(NULL, 0, 0.02, 0.2, Current + 0);
    double sar2 = iSAR(NULL, 0, 0.02, 0.2, Current + 1);
    double ma1 = iMA(NULL, 0, maperiods, 0, MODE_SMA, PRICE_CLOSE, Current + 0);
    double ma2 = iMA(NULL, 0, maperiods, 0, MODE_SMA, PRICE_CLOSE, Current + 1);
    double Buy2 = MathMax(High[1],High[2]);
    double Sell2=MathMin(Low[1],Low[2]);
    bool buycl=( High[0]>(High[1]+extra*Point+prof*Point));
    bool sellcl=(Low[0]<(Low[1]-extra*Point-prof*Point));
   //mm booleans whether to do mm was chosen and sets mmsig 
    //to use strategy anyway.
   if(Hour()==22 && Minute()>=30
   || Hour()==2 && Minute()>=30
   || Hour()==6  && Minute()>=30 
   || Hour()==10 && Minute()>=30
   || Hour()==14 && Minute()>=30 
   || Hour()==18 && Minute()>=30
   ) closehour=true;
   else 
   closehour=false;   
/*
   if(TimeHour(TimeCurrent())==23 && TimeMinute(TimeCurrent())>=50
   || TimeHour(TimeCurrent())==3  && TimeMinute(TimeCurrent())>=50
   || TimeHour(TimeCurrent())==7  && TimeMinute(TimeCurrent())>=50 
   || TimeHour(TimeCurrent())==11 && TimeMinute(TimeCurrent())>=50
   || TimeHour(TimeCurrent())==15 && TimeMinute(TimeCurrent())>=50 
   || TimeHour(TimeCurrent())==19 && TimeMinute(TimeCurrent())>=50
   ) closehour=true;
   else 
   closehour=false;
*/
 
    total  = OrdersTotal(); 
   if(total < 1) 
     {
//     if( High[0]> Close[1]+Close[1]/10000)
       if( buycl && curnum==True )   
        {
 //       Print(Time[0],"time open buy"); 
        curnum=False;
//        Print("Hello b");
         bopin=True;
         sopin=False;
 //           bslss=Bid-stp*Point;
            bslss=OrderOpenPrice()-stp*Point;
            ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,slp,0,0,"My EA",MAGICMA,0,Green);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) {Print("BUY order opened : ",OrderOpenPrice());
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-stp*Point,OrderOpenPrice()+tkp*Point,0,Green);
//              Print("New buy stop",bslss,Point,bmo);
              }
              }
            else Print("Error opening BUY order : ",GetLastError());
            return(0);
           }          
//            if (Low[0]<Close[1]-Close[1]/10000) Print("hello s");
   
    if (sellcl  && curnum==True )
        
         {
 //         Print(Time[0],"time open sell"); 
         curnum=False;
         bopin=False;
         sopin=True;
 //           sslss=Ask+stoploss*Point;
            
            ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,slp,0,0,"My EA",MAGICMA,0,Red);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) {Print("SELL order opened : ",OrderOpenPrice());
              OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+stp*Point,OrderOpenPrice()-tkp*Point,0,Green);           
              sslss=OrderOpenPrice()+stp*Point;
              }
              }
            else Print("Error opening SELL order : ",GetLastError()); 
            return(0);
         }
         return(0);
         }
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
        {
         
         int count=0;
         for (pos=OrdersTotal()-1; pos>=0; pos--)
         if (OrderSelect(pos,SELECT_BY_POS)//Only my orders
         && OrderMagicNumber()==MAGICMA  //with my magic number
         && OrderSymbol()==Symbol() ){   //and my pair
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            //TO CLOSE trades at the begining of the next bar I set curnum equal to 
            //true for a condition. To close trades at the end of the bar- a 4 hour bar.
            // I set curnum equal to fale because a trade was taken.
                if (curnum==false && endtr==True && closehour==true)
                {
                 Print(TimeHour(TimeCurrent()));
                 Print(Hour(),Minute(),"time closed long");
                 Print(Time[0],"time closed long");
                 endtr=False;
                 if(OrderClose(OrderTicket(),OrderLots(),Bid,slp,Violet)) // close position
                 continue;
                 Alert("OrderCloseFailed:",GetLastError());
//                 return(0); // exit
                }
              
 
//            check for trailing stop
//            Print(" before trailing stop",TrailingStop);
            if(TrailingStop>0)  
              {                 
//               Print("Order Open Price",OrderOpenPrice());
               bgain=(Bid-OrderOpenPrice())/10;
//               Print("gain",Bid-OrderOpenPrice());
//               Print("gain",bgain);
              bgamult=MathFloor(bgain);
 //             Print("multiplier",bgamult);
              bmo=bgamult*bmoved;       //bmo=amt to move up stop 
//              Print("move up",bmo);  
//               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 if(bmo*Point>Point*bmoved)
                 {
//                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    if(OrderStopLoss()<bslss+Point*bmo)
                    {
 //                    Print("new buy stop",bslss+Point*bmo);
                     OrderModify(OrderTicket(),OrderOpenPrice(),bslss+Point*bmo,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }// if trailing stop
           }// if buy
         else // go to short position
           {
            // should it be closed?
           if( curnum==false && endtr==True && closehour==true)
              {
               Print(TimeHour(TimeCurrent()));
                Print(Hour(),Minute(),"time closed short");
               Print(Time[0],"time closed short",Hour());
               endtr=False;
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
//               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                 sgain=(OrderOpenPrice()-Ask)/10;
                 sgamult=MathFloor(sgain);
                 smo=sgamult*smoved;       //bmo=amt to move up stop         
                 
//                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    if(OrderStopLoss()>sslss-Point*bmo)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),sslss-Point*bmo,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           count++;
           }//count down
        
        }//ordertype
        
        }// for    
          
//    }//isnewbar
    }//orders total
//}// time equal
   return(0);
  }//start
    bool IsNewBar()
  {
  datetime curbar =Time[0];//Open time of current Bar
  if(lastbar!=curbar)
  {
    lastbar=curbar;
    return(true);
    }
    return(false);
  }    

  
  //---------------------------------

